﻿Imports System.Data.SqlClient
Imports System.Configuration
Imports System.Data.Common

Module Module1
    Sub Main()
        Try
            Using conn As SqlConnection = DirectCast(GetDatabaseConnection("cevora"), SqlConnection)
                Dim selectStmt As String = "select * from rekening"

                Dim adapter As SqlDataAdapter = New SqlDataAdapter(selectStmt, conn)
                adapter.MissingSchemaAction = MissingSchemaAction.AddWithKey
                Dim builder As SqlCommandBuilder = New SqlCommandBuilder(adapter)

                ' creatie van een DataSet
                Dim ds As New DataSet()

                ' DataSet opvullen 
                adapter.Fill(ds, "rekening")

                ToonDataTable(ds)
                WijzigRekening(ds)
                ToonDataTable(ds)

                ' wijzigingen in dataset doorvoeren in databank
                adapter.Update(ds, "rekening")
            End Using
        Catch exc As Exception
            Console.WriteLine("fout: " & exc.Message)
        End Try
    End Sub
    Private Sub ToonDataTable(ByVal ds As DataSet)
        Dim tabel As DataTable = ds.Tables("rekening")
        Dim aantalKolommen As Integer = tabel.Columns.Count

        ' overloop alle kolommen
        For Each kolom As DataColumn In tabel.Columns
            ' toon kolomhoofding
            Console.Write(kolom.Caption & vbTab)
        Next
        Console.WriteLine()

        ' overloop alle rijen
        For Each rij As DataRow In tabel.Rows
            If rij.RowState <> DataRowState.Deleted Then
                ' rij is niet in toestand "verwijderd"
                ' overloop alle kolommen
                For kolom As Integer = 0 To aantalKolommen - 1
                    Console.Write(rij(kolom) & vbTab)
                Next
                Console.WriteLine()
            End If
        Next
    End Sub

    Private Sub WijzigRekening(ByVal ds As DataSet)
        ' opvragen gegevens te wijzigen rekening
        Console.WriteLine("*** GEGEVENS WIJZIGEN ***")
        Console.Write("nummer: ")
        Dim id As String = Console.ReadLine()
        Console.Write("bedrag: ")
        Dim bedrag As Decimal = Decimal.Parse(Console.ReadLine())

        Dim tabel As DataTable = ds.Tables("rekening")

        ' zoek datarij met opgegeven PK
        Dim rij As DataRow = tabel.Rows.Find(id)

        If rij IsNot Nothing Then
            ' rij met opgegeven PK gevonden
            ' wijzig naam van de rij 
            rij("bedrag") = bedrag
        End If
    End Sub

    Private Function GetDatabaseConnection(ByVal naam As String) As DbConnection
        ' connection string opvragen uit config file
        Dim settingsColl As ConnectionStringSettingsCollection = ConfigurationManager.ConnectionStrings
        Dim settings As ConnectionStringSettings = settingsColl(naam)

        If settings IsNot Nothing Then
            Try
                Dim factory As DbProviderFactory = DbProviderFactories.GetFactory(settings.ProviderName)
                Dim conn As DbConnection = factory.CreateConnection()
                conn.ConnectionString = settings.ConnectionString
                Return conn
            Catch exc As Exception
                Throw exc
            End Try
        Else
            Throw New Exception("geen connectionstring gevonden met naam " & naam & " in config file")
        End If
    End Function
End Module
