﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


//
// datacontext klasse genereren met tool:
//sqlmetal /code:"c:\projects\linq03\introdotnet.cs" /language:csharp "introdotnet.mdf"
//

namespace linq03
{
    class Program
    {
        static void Main(string[] args)
        {
            using (Introdotnet db = new Introdotnet(@"Data Source=(localDB)\V11.0;AttachDbFilename=|DataDirectory|\introdotnet.mdf;Integrated Security=True"))
            {
                db.Log = Console.Out;
                Auteur auteur = new Auteur();
                auteur.Auteurid = 6;
                auteur.Naam = "Pieter Aspe";
                auteur.Gebdatum = new DateTime(1953, 4, 3);
                db.Auteur.InsertOnSubmit(auteur);
                db.SubmitChanges();
                foreach (var aut in db.Auteur)
                {
                    Console.WriteLine("{0}({1})", aut.Naam, aut.Gebdatum);
                }
                var bestaandeAuteur = (from c in db.Auteur
                                       where c.Auteurid == 6
                                       select c).First();
                bestaandeAuteur.Gebdatum = new DateTime(1953, 4, 5);
                db.SubmitChanges();
                foreach (var aut in db.Auteur)
                {
                    Console.WriteLine("{0}({1})", aut.Naam, aut.Gebdatum);
                }
                bestaandeAuteur = (from c in db.Auteur
                                   where c.Auteurid == 6
                                   select c).First();
                db.Auteur.DeleteOnSubmit(bestaandeAuteur);
                db.SubmitChanges();
                var qryLev = from a in db.Auteur
                             select new { id = a.Auteurid, naam = a.Naam };
                foreach (var item in qryLev)
                {
                    Console.WriteLine(item.id + " " + item.naam);
                }
            }
        }
    }
}
